﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Windows.Data;
using Infragistics.Controls.Menus;

namespace SilverlightApplication1
{
    public class DataUtil
    {

    }

    public class Node : INotifyPropertyChanged
    {

        private string text;

        

        public event PropertyChangedEventHandler PropertyChanged;



        protected void RaisePropertyChanged(string propertyName)
        {

            if (PropertyChanged != null)
            {

                this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));

            }

        }



        public string Text
        {

            get { return text; }

            set
            {

                if (text != value)
                {

                    text = value;

                    RaisePropertyChanged("Text");

                }

            }

        }

    }



    public class Folder : Node
    {

        private ObservableCollection<Node> children;
     


        public ObservableCollection<Node> Children
        {

            get { return children; }

            set
            {

                if (children != value)
                {

                    children = value;

                    this.RaisePropertyChanged("Children");

                }

            }

        }

        

    }



    public class File : Node
    {

    }


    public class NodeConverter : IValueConverter
    {

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value != null && value.GetType() == typeof(XamDataTreeNodeDataContext))
            
            {
                var data = (value as XamDataTreeNodeDataContext).Data;

                if (data.GetType() == typeof(Folder))
                {
                    Folder fld = (Folder)data;
                    StackPanel sp = new StackPanel();
                    sp.Orientation = Orientation.Horizontal;
                    Ellipse e = new Ellipse();
                    e.Height = 15;
                    e.Width = 10;
                    SolidColorBrush brsh = new SolidColorBrush(Colors.Purple);
                    e.Fill = brsh;
                    e.StrokeThickness = 1;
                    e.Stroke = new SolidColorBrush(Colors.Black);
                    sp.Children.Add(e);
                    TextBlock tb = new TextBlock();
                    tb.TextAlignment = TextAlignment.Left;
                    tb.FontSize = 11;
                    tb.Text = fld.Text;
                    tb.VerticalAlignment = VerticalAlignment.Center;

                    sp.Children.Add(tb);

                    return sp;

                }
                else
                {
                    StackPanel sp = new StackPanel();
                    sp.Orientation = Orientation.Horizontal;
                    Rectangle r = new Rectangle();
                    r.Height = 15;
                    r.Width = 10;
                    r.Fill = new SolidColorBrush(Colors.Orange);
                    sp.Children.Add(r);
                    File fl = (File)data;
                    TextBlock tb = new TextBlock();
                    tb.TextAlignment = TextAlignment.Left;
                    tb.FontSize = 11;
                    
                    tb.VerticalAlignment = VerticalAlignment.Center;
                    tb.Text = fl.Text;
                    sp.Children.Add(tb);
                    return sp;
                }

            }

            return "";
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

}
